#include "ACEXML/common/FileCharStream.h"
#include "ACEXML/parser/parser/Parser.h"

//xmlļн࣬ݱĸʽHANDLER
//HANDLER ̳ACEXML_DefaultHandler࣬ṩ"string path();"ķ
//ע⣺˶ṩ̻̰߳ʵĹ
template< typename HANDLER>
class xml_parser
{
public:
	static bool parse(HANDLER& handler)
	{
		ACEXML_FileCharStream* fstm = new(std::nothrow)ACEXML_FileCharStream();
		if(!fstm)
		{
			return false;
		}
		string path = handler.path();
		if(path.empty())
		{
			return false;
		}
		fstm->open(path.c_str());
		//ACEXML_InputSourceлͨdelete fstmͷڴ
		ACEXML_InputSource input(fstm);
		ACEXML_Parser parser;
		parser.setContentHandler(&handler);
		parser.setDTDHandler(&handler);
		parser.setEntityResolver(&handler);
		parser.setErrorHandler(&handler);
		try
		{
			parser.parse(&input);
		}
		catch(const ACEXML_Exception* ex)
		{
			ex->print();
			return false;
		}
		catch(std::bad_alloc& ex)
		{
			return false;
		}
		return true;
	}
};