#include "xml_handler.h"
#include "xml_parser.h"

int main(int argc, char* argv[])
{
	xml_handler handler("D:\\test.xml");
	xml_parser<xml_handler>::parse(handler);
	cout << "root version:" << handler.root().version << ", count:" << handler.root().count << endl;
	cout << "---------------------" << endl;
	for(size_t i=0; i<handler.count(); ++i)
	{
			cout << "file id:" << handler[i]->id << ", path:" << handler[i]->path << endl;
	}
	return 0;
};